//+------------------------------------------------------------------+
//|                                                    EMACCROSS.mq4 |
//|                                                   Gryb Alexander |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Gryb Alexander"
#property link      ""
extern string comment1 =" ";
extern int fastMAPeriod = 5;
extern int fastMAMetod = 1;
extern string comment2 =" ";
extern int slowMAPeriod = 14;
extern int slowMAMetod = 1;
extern string comment3 =", ";
extern int takeProfit = 50;
extern int stopLoss = 30;
extern int lot = 1;
extern string comment4 = "      ";
extern int barsToSaveSignal = 5;

bool signalBuy = false;
datetime signalBuyTime;
bool signalSell = false;
datetime signalSellTime;
double signalBarHigh = 0;
double signalBarLow = 0;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   int k;
   bool doOpen = true;
   GetSignals();
   for(k=0;k<OrdersTotal();k++)
   {
    OrderSelect(k,SELECT_BY_POS);
    if(OrderComment()=="MAcrossPosition "+Symbol())
    {
      CheckForClose(k);
    }
   }
   for(k=0;k<OrdersTotal();k++)
   {
    OrderSelect(k,SELECT_BY_POS);
    if(OrderComment()=="MAcrossPosition "+Symbol())
    {
      doOpen=false;
    }
   }
   
   if(doOpen==true)
     CheckForOpen();
   
//----
   return(0);
  }
void GetSignals()
{
  double fMA1 = iMA(Symbol(),0,fastMAPeriod,0,MODE_EMA,PRICE_CLOSE,1);
  double fMA2 = iMA(Symbol(),0,fastMAPeriod,0,MODE_EMA,PRICE_CLOSE,2);
  
  double sMA1 = iMA(Symbol(),0,slowMAPeriod,0,MODE_EMA,PRICE_CLOSE,1);
  double sMA2 = iMA(Symbol(),0,slowMAPeriod,0,MODE_EMA,PRICE_CLOSE,2);
  if((fMA1>=sMA1)&&(fMA2<sMA2))
  {
    signalBuyTime =Time[1];
    signalBarHigh = High[1];
    signalSellTime = 0;
    signalBarLow = 00;
  }
  if((fMA1<=sMA1)&&(fMA2>sMA2))
  {
    signalSellTime = Time[1];
    signalBarLow = Low[1];
    
    signalBuyTime = 0;
    signalBarHigh = 10000;
  }
}
void CheckForOpen()
{
  if(iBarShift(Symbol(),0,signalBuyTime)<barsToSaveSignal)
  {
   if(Ask>(signalBarHigh+Point))
      OrderSend(Symbol(),OP_BUY,lot,Ask,2,(Ask-stopLoss*Point),(Ask+takeProfit*Point),"MAcrossPosition "+Symbol());
  }
  if(iBarShift(Symbol(),0,signalSellTime)<barsToSaveSignal)
   {
    if(Bid<(signalBarLow-Point))
       OrderSend(Symbol(),OP_SELL,lot,Bid,2,(Ask+stopLoss*Point),(Ask-takeProfit*Point),"MAcrossPosition "+Symbol());
   }
}
void CheckForClose(int orderNum)
{
  OrderSelect(orderNum,SELECT_BY_POS);
  if(iBarShift(Symbol(),0,signalBuyTime)<barsToSaveSignal)
  {
   if(Ask>(signalBarHigh+Point))
      if(OrderType()==OP_SELL) OrderClose(OrderTicket(),OrderLots(),Ask,2);
  }
  if(iBarShift(Symbol(),0,signalSellTime)<barsToSaveSignal)
   {
    if(Bid<(signalBarLow-Point))
      if(OrderType()==OP_BUY) OrderClose(OrderTicket(),OrderLots(),Bid,2);
   }
  
}
//+------------------------------------------------------------------+